import java.awt.*;

public class FillObject
{
  int fNumVertices;
  int fNumPolygons;
  int fX,fY,fZ;       // world coordinate
  FillPolygon fPolygons[];
  FillVertex fVertices[];

  Graphics fOffScrGraphics;// for drawing
  int fScrWidth, fScrHeight;
  int fScrMidX, fScrMidY;

  public FillObject()
  {
  }

  public void Transform(FillMatrix tMatrix)
  {
    for (int i=0;i<fNumVertices;i++)
    {
      fVertices[i].fWx=(int)(fVertices[i].fLx*tMatrix.fMatrix[0][0]+
        fVertices[i].fLy*tMatrix.fMatrix[1][0]+
        fVertices[i].fLz*tMatrix.fMatrix[2][0]+
        tMatrix.fMatrix[3][0]);
      fVertices[i].fWy=(int)(fVertices[i].fLx*tMatrix.fMatrix[0][1]+
        fVertices[i].fLy*tMatrix.fMatrix[1][1]+
        fVertices[i].fLz*tMatrix.fMatrix[2][1]+
        tMatrix.fMatrix[3][1]);
      fVertices[i].fWz=(int)(fVertices[i].fLx*tMatrix.fMatrix[0][2]+
        fVertices[i].fLy*tMatrix.fMatrix[1][2]+
        fVertices[i].fLz*tMatrix.fMatrix[2][2]+
        tMatrix.fMatrix[3][2]);
    }
  }

  public void Project(int distance)
  {
    for (int i=0;i<fNumVertices;i++)
    {
      fVertices[i].fSx=distance*fVertices[i].fWx/fVertices[i].fWz;
      fVertices[i].fSy=distance*fVertices[i].fWy/fVertices[i].fWz;
    }
  }

  // do not call this before creating the polygons
  public void SetGraphics(Graphics offScrGraphics,
    int scrWidth, int scrHeight, int midX, int midY)
  {
    fScrWidth=scrWidth;
    fScrHeight=scrHeight;
    fScrMidX=midX;
    fScrMidY=midY;
    fOffScrGraphics=offScrGraphics;

    fOffScrGraphics.clipRect(0,0,scrWidth-1,scrHeight-1);
    for (int i=0;i<fNumPolygons;i++)
    {
      fPolygons[i].SetGraphics(offScrGraphics, scrWidth, scrHeight,
        midX, midY);
    }
  }

  public void Draw()
  {
    // draw the polygons that are not backfaced
    for (int i=0; i<fNumPolygons;i++)
    {
      if (fPolygons[i].Backface()==false)
      {
        fOffScrGraphics.setColor(new Color((i*10)+150,0,0));
        fPolygons[i].Draw();
      }
    }
  }

  public void SetVertices(FillVertex[] v, int numVert)
  {
    int i;
    int j=0;

    fVertices = new FillVertex[numVert];
    for (i=0;i<numVert;i++)
    {
      fVertices[i]=v[i];
    }
    fNumVertices=numVert;
  }

  public void SetPolygons(int[] vList, int[] numVert, int numPolys)
  {
    int i;
    int j=0;

    fPolygons = new FillPolygon[numPolys];
    for (i=0;i<numPolys;i++)
    {
      fPolygons[i]=new FillPolygon();
      fPolygons[i].fVertices=new FillVertex[numVert[i]];
      fPolygons[i].fNumVertices=numVert[i];
      for (int o=0;o<numVert[i];o++)
      {
        fPolygons[i].fVertices[o]=fVertices[vList[j++]];
      }
    }
    fNumPolygons=numPolys;
  }
}